/// @file
////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Copyright (C) 2017/18      Christian Lessig, Otto-von-Guericke Universitaet Magdeburg
///
////////////////////////////////////////////////////////////////////////////////////////////////////
///
///  module     : tutorial 7
///
///  author     : lessig@isg.cs.ovgu.de
///
///  project    : GPU Programming
///
///  description: CUDA basics
///
////////////////////////////////////////////////////////////////////////////////////////////////////

#include <iostream>

#include "cuda_util.h"

////////////////////////////////////////////////////////////////////////////////////////////////////
// add constant to vector
////////////////////////////////////////////////////////////////////////////////////////////////////
__global__
void
vecAddC( float* data, const unsigned int n, const float val) {

  // TODO
}

////////////////////////////////////////////////////////////////////////////////////////////////////
// program entry point
////////////////////////////////////////////////////////////////////////////////////////////////////
int
main( int /*argc*/, char** /*argv*/ ) {

  const unsigned int n = 16;
  float* data = (float*) malloc( sizeof(float) * n);
  for( unsigned int i = 0; i < n; ++i) {
    data[i] = (float) i;
  }

  // get number of CUDA devices
  int deviceCount = 0;

  // query the device properties
  // TODO

  // set the device
  // TODO

  // initialize memory
  // TODO

  // allocate device memory
  // TODO

  // copy device memory
  // TODO

  // determine thread layout
  // TODO

  // run kernel
  // TODO

  // copy result back to host
  // TODO

  // output
  for( unsigned int i = 0; i < n; ++i) {
    std::cout << "data[" << i << "] = " << data[i] << '\n';
  }

  // clean up device memory
  // TODO

  // clean up host memory
  free( data);

  return EXIT_SUCCESS;
}
